version: "3.7"

services:
  mongo:
    container_name: happyq-queues-mongo
    image: mongo:latest
    restart: always
    environment:
      MONGO_INITDB_DATABASE: happyq
    ports:
      - 27017:27017
    healthcheck:
      test: echo 'db.runCommand("ping").ok' | mongo mongo:27017/test --quiet 1
      retries: 3
    volumes:
      - mongodb:/data/db
    logging:
      driver: none

  redis:
    image: redis:alpine
    container_name: happyq-queues-redis
    restart: always
    volumes:
      - redis:/var/lib/redis
      - redis:/usr/local/etc/redis/redis.conf
    logging:
      driver: none

  happyq-queues:
    build:
      context: .
      dockerfile: dockerfile.happyq_queues
    container_name: happyq-queues
    ports:
      - 8080:8080
    environment:
      QUEUES_MONGO_URI: mongodb://mongo:27017/
      QUEUES_MONGO_DB: happyq
      QUEUES_API_HOST: 0.0.0.0:8080
      QUEUES_GIN_MODE: debug
      QUEUES_REDIS_URI: redis:6379
    depends_on:
      - mongo
      - redis

volumes:
  mongodb:
  redis:
